//
//  Gob1MenuViewController.m
//  scummvm
//
//  Created by DotEmu on 17/05/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//
#include <semaphore.h>
#import "osys_main.h"
#import <engines/igob/gob.h>
#import "switchViewController.h"
#import "iPhoneViewController.h"
#import "Gob1MenuViewController.h"
#import "iphone_main.h"
#import "BulkyServices.h"

//////////////////
//---GAME PARAMS
//GAME (GENERAL)
extern bool bMenuGob1;
extern bool bFromMenuIngame;
extern bool bSaveActive;
extern bool bNewGame;

bool bLoad = false;
//LVL (SIMULATION)
extern bool bSimulation;
extern bool bLoadSimulLaunch;
//SOUND
extern bool bSoundMusicActive;
extern int idSoundMusic;
extern int idSoundSFX;
extern UInt32 isiPodPlaying;
AVAudioPlayer* menuPlayer;
//DEFINE
extern switchViewController* g_switchVC;
extern iPhoneViewController* g_iVC;
//---END
////////////////

extern bool _dueToBulky;
extern bool _musicDueToBulky;
extern bool bSleepMode;
extern bool bSem;
extern sem_t* sem;

//XML
NSString* STORE_GAME = @"";

extern NSString* _plat;

@implementation Gob1MenuViewController
@synthesize _creditsVC, _helpVC, _settingsVC, _loadVC;

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

-(void)effectFinishedLeft:(NSString *)animationID finished:(NSNumber *)finished context:(void *)context 
{	
	if( bAnimationOn )
	{
		[self launchEffet];
	}
	else
	{
		//NSLog(@"_effect hidden");		
		_effect.hidden = YES;
	}
}

-(void)launchEffet
{
	if( bAnimationOn )
	{
		//NSLog(@"_effect");
		if( _effect != nil )
			_effect.frame = CGRectMake( -22, -61, 152, 202 );		
		else 
			_effect = [[UIImageView alloc] initWithFrame:CGRectMake( -22, -61, 152, 202 )];
		
		_effect.hidden = NO;
		[UIView beginAnimations:nil context:self]; 
		{
			[UIView setAnimationDuration:2];
			[UIView setAnimationDelegate:self];
			[UIView setAnimationCurve:UIViewAnimationCurveLinear];
			[UIView setAnimationDidStopSelector:@selector(effectFinishedLeft:finished:context:)];
			_effect.frame = CGRectMake( 368, -61, 152, 202 );
		}
		[UIView commitAnimations];
	}
	else
	{
		//NSLog(@"_effect hidden");		
		_effect.hidden = YES;
	}
}

-(void)eyeLeftFinishedLeft:(NSString *)animationID finished:(NSNumber *)finished context:(void *)context 
{	
	if( bAnimationOn )
	{
		//NSLog(@"eye left");
		if( _eye != nil )
			_eye.frame = CGRectMake( 208, 165, 24, 24 );		
		else 
			_eye = [[UIImageView alloc] initWithFrame:CGRectMake( 208, 165, 24, 24 )];
		
		_eye.hidden = NO;
		[UIView beginAnimations:nil context:self]; 
		{
			[UIView setAnimationDuration:0.5];
			[UIView setAnimationDelegate:self];
			[UIView setAnimationCurve:UIViewAnimationCurveLinear];
			[UIView setAnimationDidStopSelector:@selector(eyeRightFinishedLeft:finished:context:)];
			_eye.frame = CGRectMake( 232, 165, 24, 24 );	
		}
		[UIView commitAnimations];
	}
	else
	{
		//NSLog(@"eye left");		
		_eye.hidden = YES;
	}
}

-(void)eyeRightFinishedLeft:(NSString *)animationID finished:(NSNumber *)finished context:(void *)context 
{	
	if( bAnimationOn )
	{
		//NSLog(@"eye right");
		if( _eye != nil )
			_eye.frame = CGRectMake( 232, 165, 24, 24 );		
		else 
			_eye = [[UIImageView alloc] initWithFrame:CGRectMake( 232, 165, 24, 24 )];
		
		_eye.hidden = NO;
		[UIView beginAnimations:nil context:self]; 
		{
			[UIView setAnimationDuration:0.5];
			[UIView setAnimationDelegate:self];
			[UIView setAnimationCurve:UIViewAnimationCurveLinear];
			[UIView setAnimationDidStopSelector:@selector(eyeLeftFinishedLeft:finished:context:)];
			_eye.frame = CGRectMake( 208, 165, 24, 24 );	
		}
		[UIView commitAnimations];
	}
	else
	{
		//NSLog(@"eye right");		
		_eye.hidden = YES;
	}
}

-(void)launchEye
{
	if( bAnimationOn )
	{
		//NSLog(@"eye middle");
		if( _eye != nil )
			_eye.frame = CGRectMake( 220, 165, 24, 24 );		
		else 
			_eye = [[UIImageView alloc] initWithFrame:CGRectMake( 220, 165, 24, 24 )];
		
		_eye.hidden = NO;
		[UIView beginAnimations:nil context:self]; 
		{
			[UIView setAnimationDuration:0.5];
			[UIView setAnimationDelegate:self];
			[UIView setAnimationCurve:UIViewAnimationCurveLinear];
			[UIView setAnimationDidStopSelector:@selector(eyeLeftFinishedLeft:finished:context:)];				
			_eye.frame = CGRectMake( 208, 165, 24, 24 );				
		}
		[UIView commitAnimations];
	}
	else
	{
		//NSLog(@"eye middle");		
		_eye.hidden = YES;
	}
}
bool bulkyok = false;

-(void)bulkyokok
{
	bulkyok = true;
}

-(void)createBulkyChannel
{
	//NSLog(@"Create Bulky Channel");
	if( bulkyView == nil )
	{
		bulkyView = [[[BulkyServicesView sharedInstance] initwithDelegate:self withBulkyShop:NO withBulkyChannel:YES] retain];
		[bulkyView setRatingFrequency:30 withAppName:@"Gobliins 2" withAppId:@"422568236"];
		[self.view addSubview:bulkyView];			
		[[UIApplication sharedApplication] setStatusBarOrientation:UIInterfaceOrientationPortrait animated:NO];
		[[BulkyServicesView sharedInstance] refreshFromApplicationOrientation];		
		[[BulkyServicesView sharedInstance] showBulkyChannel:YES at:CGPointMake(35,290)];
		
		[NSTimer scheduledTimerWithTimeInterval:2.5 target:self selector:@selector(bulkyokok) userInfo:nil repeats:NO];	
	}
}

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad 
{
	//NSLog(@"Gob1MenuViewController viewDidLoad");
    [super viewDidLoad]; 
	bulkyok = false;
		
	_new.enabled = YES;
	_load.enabled = YES;
	_settings.enabled = YES;
	_help.enabled = YES;
	_credits.enabled = YES;
	
	_new.exclusiveTouch = YES;
	_load.exclusiveTouch = YES;
	_settings.exclusiveTouch = YES;
	_help.exclusiveTouch = YES;
	_credits.exclusiveTouch = YES;
	
	NSURL *url = [NSURL fileURLWithPath:[NSString stringWithFormat:@"%@/music_menu_48.mp3", [[NSBundle mainBundle] resourcePath]]];
	NSError *err;
	if( menuPlayer == nil )
		menuPlayer = [[AVAudioPlayer alloc] initWithContentsOfURL:url error:&err];			 
	
	//Si on a la musique du jeu d'active
	 if( bSoundMusicActive )
	 {
		 if( menuPlayer != nil )
		 {
			 [menuPlayer stop];
			 menuPlayer.volume = (float)((float)idSoundMusic / 256.0f);
			 menuPlayer.numberOfLoops = -1;
			 if( self.view.alpha == 1 && !_musicDueToBulky )
			 {
				 [menuPlayer play];			 
			 }
		 }
	 }
	
	//STORE NEWS
	STORE_GAME = @"";
	_pastille.hidden = YES;
	_digitStore.hidden = YES;
	
	// Create the request.
	NSURLRequest *theRequest=[NSURLRequest requestWithURL:[NSURL URLWithString:@"http://corporate.dotemu.com/iPhoneStoreNews.xml"]
											  cachePolicy:NSURLRequestUseProtocolCachePolicy
										  timeoutInterval:60.0];
	
	// create the connection with the request and start loading the data
	NSURLConnection *theConnection=[[NSURLConnection alloc] initWithRequest:theRequest delegate:self];
	if (theConnection) 
	{
		//NSLog(@"connection OK");	
	    _storeData = [[NSMutableData data] retain];
	} 
	else 
	{
		// Inform the user that the connection failed.
		//NSLog(@"connection failed");
	}
	//-----
	
	// Emulated CD support through MP3
	url = [NSURL fileURLWithPath:[NSString stringWithFormat:@"%@/button-25.mp3", [[NSBundle mainBundle] resourcePath]]];

	menuSFXPlayer = [[AVAudioPlayer alloc] initWithContentsOfURL:url error:&err];
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	menuSFXPlayer.numberOfLoops = 0;
	
	if( g_iVC != nil )
	{
		g_system->getMixer()->setVolumeForSoundType(Audio::Mixer::kMusicSoundType, 0);
		g_system->getMixer()->setVolumeForSoundType(Audio::Mixer::kSFXSoundType, 0);
	}
	
	//ANIMATION
	bAnimationOn = true;
	[self launchEffet];
	[self launchEye];

	[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(pauseAnimNotification)  name:@"pauseAnimNotif" object:nil];	
	[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(resumeAnimNotification)  name:@"resumeAnimNotif" object:nil];	
	[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(stopAnimNotification)  name:@"stopAnimNotif" object:nil];	
	[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(startAnimNotification)  name:@"startAnimNotif" object:nil];		
	[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(storeUpdateOnNotification:)  name:@"storeUpdateOnNotif" object:nil];	
	[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(storeUpdateOffNotification:)  name:@"storeUpdateOffNotif" object:nil];
	[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(enableButtonMenuNotification:)  name:@"enableButtonMenuNotif" object:nil];	
	
	//Bulky channel
	[NSTimer scheduledTimerWithTimeInterval:1 target:self selector:@selector(createBulkyChannel) userInfo:nil repeats:NO];	
}

///----NOTIFICATIONS
-(void)pauseAnimNotification
{
	[self performSelectorOnMainThread:@selector(pauseAnim) withObject: nil waitUntilDone:NO];
}

-(void)resumeAnimNotification
{
	[self performSelectorOnMainThread:@selector(resumeAnim) withObject: nil waitUntilDone:NO];
}

-(void)stopAnimNotification
{
	[self performSelectorOnMainThread:@selector(stopAnim) withObject: nil waitUntilDone:NO];
}

-(void)startAnimNotification
{
	[self performSelectorOnMainThread:@selector(startAnim) withObject: nil waitUntilDone:NO];
}

- (void)storeUpdateOffNotification:(NSNotification*)_notif
{
	_pastille.hidden = YES;
	_digitStore.hidden = YES;
}

- (void)storeUpdateOnNotification:(NSNotification*)_notif
{
	_pastille.hidden = NO;
	_digitStore.hidden = NO;
}

- (void)enableButtonMenuNotification:(NSNotification*)_notif
{
	_new.enabled = YES;
	_load.enabled = YES;
	_settings.enabled = YES;
	_help.enabled = YES;
	_credits.enabled = YES;
	
	_new.exclusiveTouch = YES;
	_load.exclusiveTouch = YES;
	_settings.exclusiveTouch = YES;
	_help.exclusiveTouch = YES;
	_credits.exclusiveTouch = YES;
}
///----

-(void)pauseAnim
{
	//NSLog(@"Stop Anim");
	bAnimationOn = false;	
	_effect.hidden = YES;	
	_eye.hidden = YES;
}

-(void)resumeAnim
{
	//NSLog(@"Start Anim");
	bAnimationOn = true;	
	_effect.hidden = NO;	
	_eye.hidden = NO;
	if( !_dueToBulky )
		[self launchEye];
	else 
		_dueToBulky = false;
}

-(void)stopAnim
{
	//NSLog(@"Stop Anim");
	bAnimationOn = false;
}

-(void)startAnim
{
	//NSLog(@"Start Anim");
	bAnimationOn = true;
	[self launchEffet];
}

// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation 
{
    // Return YES for supported orientations
    return ( interfaceOrientation == UIInterfaceOrientationLandscapeRight || interfaceOrientation == UIInterfaceOrientationLandscapeLeft );
}

-(void) releaseView
{
	//NSLog(@"Gob1MenuViewController releaseView");

	if( _settingsVC != nil )
	{
		[_settingsVC.view removeFromSuperview];
		[_settingsVC release];
		_settingsVC = nil;
	}
	/*if( _loadVC != nil )
	{
		[_loadVC.view removeFromSuperview];
		[_loadVC release];
		_loadVC = nil;
	}*/
	if( _creditsVC != nil )
	{
		[_creditsVC.view removeFromSuperview];
		[_creditsVC release];
		_creditsVC = nil;
	}
	if( _helpVC != nil )
	{
		[_helpVC.view removeFromSuperview];
		[_helpVC release];
		_helpVC = nil;
	}
}

- (void)didReceiveMemoryWarning
{
	//NSLog(@"Gob1MenuViewController didReceiveMemoryWarning");
	
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
	[menuSFXPlayer stop];
	[menuPlayer stop];
	bAnimationOn = false;	
	
	//release
	[self releaseView];
	
	if( menuPlayer != nil )
	{
		[menuPlayer release];
		menuPlayer = nil;
	}
	if( menuSFXPlayer != nil )
	{
		[menuSFXPlayer release];
		menuSFXPlayer = nil;
	}
}

- (void)viewDidUnload 
{
	//NSLog(@"Gob1MenuViewController viewDidUnload");
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}

- (void)dealloc 
{
	//NSLog(@"Gob1MenuViewController dealloc");	

	bAnimationOn = false;	
		
	if( menuPlayer != nil )
	{
		[menuPlayer release];
		menuPlayer = nil;
	}
	
	if( menuSFXPlayer != nil )
	{
		[menuSFXPlayer release];
		menuSFXPlayer = nil;
	}
	
	if( _effect != nil )
	{
		[_effect removeFromSuperview];
		[_effect release];
		_effect = nil;
	}
	
	if( _eye != nil )
	{
		[_eye removeFromSuperview];
		[_eye release];
		_eye = nil;
	}
	
	if( logoV != nil )
	{
		[logoV removeFromSuperview];
		[logoV release];
		logoV = nil;
	}
	
	if( _new != nil )
	{
		[_new removeFromSuperview];
		[_new release];
		_new = nil;
	}
	if( _load != nil )
	{
		[_load removeFromSuperview];
		[_load release];
		_load = nil;
	}
	if( _settings != nil )
	{
		[_settings removeFromSuperview];
		[_settings release];
		_settings = nil;
	}
	if( _help != nil )
	{
		[_help removeFromSuperview];
		[_help release];
		_help = nil;
	}
	if( _credits != nil )
	{
		[_credits removeFromSuperview];
		[_credits release];
		_credits = nil;
	}
	
	/*if( bulkyView != nil )
	{
		[bulkyView release];
		bulkyView = nil;
	}*/
	
	if( _settingsVC != nil )
	{
		[_settingsVC.view removeFromSuperview];
		[_settingsVC release];
		_settingsVC = nil;
	}
	if( _loadVC != nil )
	{
		[_loadVC.view removeFromSuperview];
		[_loadVC release];
		_loadVC = nil;
	}
	if( _creditsVC != nil )
	{
		[_creditsVC.view removeFromSuperview];
		[_creditsVC release];
		_creditsVC = nil;
	}
	if( _helpVC != nil )
	{
		[_helpVC.view removeFromSuperview];
		[_helpVC release];
		_helpVC = nil;
	}
	
	//XML
	if( _pastille != nil )
	{
		[_pastille removeFromSuperview];		
		[_pastille release];
		_pastille = nil;
	}
	if( _digitStore != nil )
	{
		[_digitStore removeFromSuperview];		
		[_digitStore release];
		_digitStore = nil;
	}
	if( _storeData != nil )
	{
		[_storeData release];
		_storeData = nil;
	}
	
    [super dealloc];
}

-(void) removeMe
{		
	[self.view removeFromSuperview];
}

- (void) reStartGame
{
	Gob::GobEngine *gg = (Gob::GobEngine*)g_engine;//(Gob::GobEngine*)[g_iVC getGobEngine];
	gg->quitGame();
	//g_engine->quitGame();
	
	[self releaseView];
	[NSTimer scheduledTimerWithTimeInterval:0.5 target:self selector:@selector(removeMe) userInfo:nil repeats:NO];
}

-(IBAction) newGameClicked:(id)sender
{
	//NSLog(@"Gob1MenuViewController newGameClicked");
	if( bulkyok )
	{
		_new.enabled = NO;
		_load.enabled = NO;
		_settings.enabled = NO;
		_help.enabled = NO;
		_credits.enabled = NO;
		
		if( [UIApplication sharedApplication].statusBarOrientation == UIInterfaceOrientationPortrait )	
			[[UIApplication sharedApplication] setStatusBarOrientation:UIInterfaceOrientationLandscapeRight animated:NO];
		else
			[[UIApplication sharedApplication] setStatusBarOrientation:[UIApplication sharedApplication].statusBarOrientation animated:NO];		
		bMenuGob1 = false;
		bSimulation = false;
		bLoadSimulLaunch = false;	
		bNewGame = true;
		
		//DEBUG
		bSleepMode = false;
		if( bSem )
		{
			sem_post( sem );		
			bSem = false;
		}
		
		[menuSFXPlayer stop];	
		menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
		[menuSFXPlayer play];
		
		if( bFromMenuIngame )
		{
			[[NSNotificationCenter defaultCenter] postNotificationName:@"loadingScreenOnNotif" object:nil];	
			self.view.alpha = 0;
			
			if( [_plat isEqualToString:@"iPhone3,1"] || [_plat isEqualToString:@"iPhone2,1"] || [_plat isEqualToString:@"iPod3,1"] || [_plat isEqualToString:@"iPod4,1"] )
			{
				[NSTimer scheduledTimerWithTimeInterval:3.5
												 target:self selector:@selector(reStartGame) userInfo:nil repeats:NO];
			}
			else
			{
				[NSTimer scheduledTimerWithTimeInterval:1
												 target:self selector:@selector(reStartGame) userInfo:nil repeats:NO];				
			}
		}
		else
		{		
			[g_switchVC switchViews];	
			[[NSNotificationCenter defaultCenter] postNotificationName:@"loadingScreenOnNotif" object:nil];			
		}	
		bAnimationOn = false;
		
		[menuPlayer stop];
	}
}

-(IBAction) loadGameClicked:(id)sender
{
	//NSLog(@"Gob1MenuViewController loadGameClicked");
	_new.enabled = NO;
	_load.enabled = NO;
	_settings.enabled = NO;
	_help.enabled = NO;
	_credits.enabled = NO;
	
	if( [UIApplication sharedApplication].statusBarOrientation == UIInterfaceOrientationPortrait )	
		[[UIApplication sharedApplication] setStatusBarOrientation:UIInterfaceOrientationLandscapeRight animated:NO];
	else
		[[UIApplication sharedApplication] setStatusBarOrientation:[UIApplication sharedApplication].statusBarOrientation animated:NO];		
	bSaveActive = false;
	bLoad = true;
	
	[menuSFXPlayer stop];	
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	[menuSFXPlayer play];
	
	if (self._loadVC.view.superview == nil) 
	{ 
		if (self._loadVC == nil) 
		{ 
			saveViewController *iii = [[saveViewController alloc] initWithNibName:@"saveViewController" bundle:nil]; 
			self._loadVC = iii; 
			[iii release]; 
		} 
		
		self._loadVC.view.frame = CGRectMake( self._loadVC.view.frame.size.width, 0, self._loadVC.view.frame.size.width, self._loadVC.view.frame.size.height);
		[self.view addSubview:_loadVC.view]; 
		
		[self._loadVC.view setUserInteractionEnabled: NO];
		[UIView beginAnimations:nil context:self]; 
		{
			[UIView setAnimationDuration:1.0];
			[UIView setAnimationDelegate:self];
			[UIView setAnimationDidStopSelector:@selector(showLoadMenuDidEnd:finished:context:)];
			[UIView setAnimationCurve:UIViewAnimationCurveEaseInOut];
			
			self._loadVC.view.frame = CGRectMake( 0, 0, self._loadVC.view.frame.size.width, self._loadVC.view.frame.size.height );
		}
		[UIView commitAnimations];
	}
}

- (void) showLoadMenuDidEnd:(NSString *)animationID finished:(NSNumber *)finished context:(void *)context
{
    [self._loadVC viewDidAppear: YES];
    [self._loadVC.view setUserInteractionEnabled: YES];
}

-(IBAction) settingsClicked:(id)sender
{
	//NSLog(@"Gob1MenuViewController settingsClicked");	
	_new.enabled = NO;
	_load.enabled = NO;
	_settings.enabled = NO;
	_help.enabled = NO;
	_credits.enabled = NO;
	
	[menuSFXPlayer stop];	
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	[menuSFXPlayer play];

	if (self._settingsVC.view.superview == nil) 
	{ 
		if (self._settingsVC == nil) 
		{ 
			settingsViewController *iii = [[settingsViewController alloc] initWithNibName:@"settingsViewController" bundle:nil]; 
			self._settingsVC = iii; 
			[iii release]; 
		} 
		
		self._settingsVC.view.frame = CGRectMake( self._settingsVC.view.frame.size.width, 0, self._settingsVC.view.frame.size.width, self._settingsVC.view.frame.size.height);
		[self.view addSubview:_settingsVC.view]; 	
		
		[self._settingsVC.view setUserInteractionEnabled: NO];
		[UIView beginAnimations:nil context:self]; 
		{
			[UIView setAnimationDuration:1.0];
			[UIView setAnimationDelegate:self];
			[UIView setAnimationDidStopSelector:@selector(showSettingsMenuDidEnd:finished:context:)];
			[UIView setAnimationCurve:UIViewAnimationCurveEaseInOut];
			
			self._settingsVC.view.frame = CGRectMake( 0, 0, self._settingsVC.view.frame.size.width, self._settingsVC.view.frame.size.height );
		}
		[UIView commitAnimations];
	}
}

- (void) showSettingsMenuDidEnd:(NSString *)animationID finished:(NSNumber *)finished context:(void *)context
{
    [self._settingsVC viewDidAppear: YES];
    [self._settingsVC.view setUserInteractionEnabled: YES];
}

-(IBAction) helpClicked:(id)sender
{
	//NSLog(@"Gob1MenuViewController helpClicked");	
	
	_new.enabled = NO;
	_load.enabled = NO;
	_settings.enabled = NO;
	_help.enabled = NO;
	_credits.enabled = NO;
	
	[menuSFXPlayer stop];	
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	[menuSFXPlayer play];
	
	if (self._helpVC.view.superview == nil) 
	{ 
		if (self._helpVC == nil) 
		{ 
			helpViewController *iii = [[helpViewController alloc] initWithNibName:@"helpViewController" bundle:nil]; 
			self._helpVC = iii; 
			[iii release]; 
		} 
		
		self._helpVC.view.frame = CGRectMake( self._helpVC.view.frame.size.width, 0, self._helpVC.view.frame.size.width, self._helpVC.view.frame.size.height);
		[self.view addSubview:_helpVC.view]; 	
		
		[self._settingsVC.view setUserInteractionEnabled: NO];
		[UIView beginAnimations:nil context:self]; 
		{
			[UIView setAnimationDuration:1.0];
			[UIView setAnimationDelegate:self];
			[UIView setAnimationDidStopSelector:@selector(showHelpMenuDidEnd:finished:context:)];
			[UIView setAnimationCurve:UIViewAnimationCurveEaseInOut];
			
			self._helpVC.view.frame = CGRectMake( 0, 0, self._helpVC.view.frame.size.width, self._helpVC.view.frame.size.height );
		}
		[UIView commitAnimations];	
	}
}

- (void) showHelpMenuDidEnd:(NSString *)animationID finished:(NSNumber *)finished context:(void *)context
{
    [self._helpVC viewDidAppear: YES];
    [self._helpVC.view setUserInteractionEnabled: YES];
}

-(IBAction) creditsClicked:(id)sender
{
	//NSLog(@"Gob1MenuViewController creditsClicked");		
	
	_new.enabled = NO;
	_load.enabled = NO;
	_settings.enabled = NO;
	_help.enabled = NO;
	_credits.enabled = NO;
	
	[menuSFXPlayer stop];	
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	[menuSFXPlayer play];
	
	if (self._creditsVC.view.superview == nil)
	{ 
		if (self._creditsVC == nil) 
		{ 
			creditsViewController *iii = [[creditsViewController alloc] initWithNibName:@"creditsViewController" bundle:nil]; 
			self._creditsVC = iii; 
			[iii release]; 
		} 

		self._creditsVC.view.frame = CGRectMake( self._creditsVC.view.frame.size.width, 0, self._creditsVC.view.frame.size.width, self._creditsVC.view.frame.size.height);
		[self.view addSubview:_creditsVC.view]; 	
		
		[self._creditsVC.view setUserInteractionEnabled: NO];
		[UIView beginAnimations:nil context:self]; 
		{
			[UIView setAnimationDuration:1.0];
			[UIView setAnimationDelegate:self];
			[UIView setAnimationDidStopSelector:@selector(showCreditsMenuDidEnd:finished:context:)];
			[UIView setAnimationCurve:UIViewAnimationCurveEaseInOut];
			
			self._creditsVC.view.frame = CGRectMake( 0, 0, self._creditsVC.view.frame.size.width, self._creditsVC.view.frame.size.height );
		}
		[UIView commitAnimations];			
	}
}

- (void) showCreditsMenuDidEnd:(NSString *)animationID finished:(NSNumber *)finished context:(void *)context
{
    [self._creditsVC viewDidAppear: YES];
    [self._creditsVC.view setUserInteractionEnabled: YES];
}

-(IBAction) moreGamesClicked:(id)sender
{
	//NSLog(@"Gob1MenuViewController moreGamesClicked");	
	[menuSFXPlayer stop];	
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	[menuSFXPlayer play];
	
	//[[UIApplication sharedApplication] openURL:[NSURL URLWithString: @"http://iphone.dotemu.com/"]];
	[(iPhoneMain*)[[UIApplication sharedApplication] delegate] switchToPortraitView];	
}

//BULKYCHANNEL
- (void)bulkychannelWillAppear
{
	//NSLog(@"bulkychannelWillAppear");
	//[[UIApplication sharedApplication] setStatusBarOrientation:UIInterfaceOrientationLandscapeRight animated:NO];	
	//[self pauseAnim];
	if( g_iVC != nil )
	{
		g_iVC.view.alpha = 0;
	}
}

-(void) alphaChannel
{
	g_iVC.view.alpha = 1;
}

- (void)bulkychannelWillDisappear
{ 
	//NSLog(@"bulkychannelWillDisappear");	
	//[self resumeAnim];
	if( g_iVC != nil )
	{
		[NSTimer scheduledTimerWithTimeInterval:1.25 target:self selector:@selector(alphaChannel) userInfo:nil repeats:NO];
	}
}

- (BOOL)isCategoryDisabled:(NSUInteger)icategoryid
{
	
}
- (BOOL)isContentHidden:(NSUInteger)iitemid
{
	
}
- (BOOL)isContentDisabled:(NSUInteger)iitemid
{
	
}
- (BOOL)provideContent:(NSUInteger)iitemid quantity:(NSUInteger)qty transactionid:(NSString*)tid receipt:(NSString*)receip
{
	
}
- (void)bulkyshopWillAppear
{
	
}
- (void)bulkyshopWillDisappear
{
	
}

//DELEGATES
- (void)parser:(NSXMLParser *)parser didStartElement:(NSString *)elementName 
  namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qualifiedName 
	attributes:(NSDictionary *)attributeDict 
{	
	//NSLog(@"parser start %@",elementName);
	
	if( [elementName isEqualToString:@"GAME"] )
	{
		STORE_GAME = [[attributeDict objectForKey:@"name"] retain];
	}
}

- (void)parser:(NSXMLParser *)parser foundCharacters:(NSString *)string 
{	
	
}

- (void)parser:(NSXMLParser *)parser didEndElement:(NSString *)elementName
  namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName
{
	//NSLog(@"parser end %@",elementName);	
}

//NSURLCONNECTION
- (void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response
{
    //NSLog(@"didReceiveResponse");	
    // This method is called when the server has determined that it
    // has enough information to create the NSURLResponse.
	
	
    // It can be called multiple times, for example in the case of a
    // redirect, so each time we reset the data.
	
    // receivedData is an instance variable declared elsewhere.
    [_storeData setLength:0];
}

- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data
{
    //NSLog(@"didReceiveData");	
    // Append the new data to receivedData.
    // receivedData is an instance variable declared elsewhere.
    [_storeData appendData:data];
}

- (void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error
{
    // release the connection, and the data object
    [connection release];
	
    // receivedData is declared as a method instance elsewhere
    [_storeData release];
	_storeData = nil;
	
    // inform the user
    //NSLog(@"connectiondidFailWithError - Connection failed! Error - %@ %@",
	//     [error localizedDescription],
	//     [[error userInfo] objectForKey:NSURLErrorFailingURLStringErrorKey]);
}

- (void)connectionDidFinishLoading:(NSURLConnection *)connection
{
    // do something with the data
    // receivedData is declared as a method instance elsewhere
    //NSLog(@"connectionDidFinishLoading - Succeeded! Received %d bytes of data",[_storeData length]);
	
	NSXMLParser *xmlParser = [[NSXMLParser alloc] initWithData:_storeData];
	
	//Set delegate
	[xmlParser setDelegate:self];
	
	//Start parsing the XML file.
	[xmlParser parse];	
	
	if( STORE_GAME != @"" )
	{
		NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
		if( [defaults boolForKey:STORE_GAME] == NO )
		{
			_digitStore.text = @"1";
			[[NSNotificationCenter defaultCenter] postNotificationName:@"storeUpdateOnNotif" object:nil];				
		}
		[[NSUserDefaults standardUserDefaults] synchronize];
	}
	//NSLog(@"STORE GAME : %@",STORE_GAME);
	
    // release the connection, and the data object
	[xmlParser release];
    [connection release];
	[_storeData release];
	_storeData = nil;
}


@end
