//
//  hintViewController.mm
//  scummvm
//
//  Created by DotEmu on 12/04/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#include <semaphore.h>
#import "iPhoneViewController.h"
#import "hintViewController.h"
#import "iphone_common.h"

//////////////////
//---GAME PARAMS
//GAME (GENERAL)
extern int idLvLCourant;
extern bool bSleepMode;
//GAME
extern bool bHintMenuActive;
//SOUND
extern int idSoundSFX;
//DEFINES
extern iPhoneViewController* g_iVC;
//---END
////////////////

extern bool bSem;
extern sem_t* sem;
extern int _GobLanguage;

@implementation hintViewController

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
 - (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
 if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
 // Custom initialization
 }
 return self;
 }
 */

-(void)loadWebView:(int)iii
{
	idLvL = -1;
	
	hintView.backgroundColor = [UIColor clearColor];
	hintView.opaque = NO;
	hintView.dataDetectorTypes = UIDataDetectorTypeNone;
	
	NSString *imagePath = [[NSBundle mainBundle] resourcePath];
	imagePath = [imagePath stringByReplacingOccurrencesOfString:@"/" withString:@"//"];
	imagePath = [imagePath stringByReplacingOccurrencesOfString:@" " withString:@"%20"];
	
	NSError *error = nil;
	NSString *intString;
	if( _GobLanguage == 0 )
		intString = [NSString stringWithFormat:@"%d", iii];
	else if( _GobLanguage == 1 )
		intString = [NSString stringWithFormat:@"%d_fr", iii];		
	NSString *fullPath = [[NSBundle mainBundle] pathForResource:intString ofType:@"html"];
	NSString *helpHtml = [NSString stringWithContentsOfFile:fullPath encoding:NSUTF8StringEncoding error:&error];
	
	[hintView loadHTMLString:helpHtml baseURL:[NSURL URLWithString: [NSString stringWithFormat:@"file:/%@//",imagePath]]];
	
	hintView.delegate = self;
	
	switch( iii )
	{
		case 110: //WORLD 1
			suiv.hidden = NO;
			prec.hidden = YES;
			hint1B.hidden = NO;
			hint2B.hidden = NO;
			hint3B.hidden = NO;
			break;
		case 111:
			suiv.hidden = YES;
			prec.hidden = NO;
			hint1B.hidden = NO;
			hint2B.hidden = NO;
			hint3B.hidden = NO;
			break; 
		case 120:
			suiv.hidden = NO;
			prec.hidden = YES;
			hint1B.hidden = NO;
			hint2B.hidden = NO;
			hint3B.hidden = NO;
			break;
		case 121:
			suiv.hidden = YES;
			prec.hidden = NO;
			hint1B.hidden = NO;
			hint2B.hidden = NO;
			hint3B.hidden = NO;
			break; 	
		case 280: //WORLD 2
			suiv.hidden = NO;
			prec.hidden = YES;
			hint1B.hidden = NO;
			hint2B.hidden = NO;
			hint3B.hidden = NO;
			break;
		case 281:
			suiv.hidden = YES;
			prec.hidden = NO;
			hint1B.hidden = NO;
			hint2B.hidden = NO;
			hint3B.hidden = NO;
			break; 	
		case 300: //WORLD 3
			suiv.hidden = NO;
			prec.hidden = YES;
			hint1B.hidden = NO;
			hint2B.hidden = NO;
			hint3B.hidden = NO;
			break;
		case 301:
			suiv.hidden = YES;
			prec.hidden = NO;
			hint1B.hidden = NO;
			hint2B.hidden = NO;
			hint3B.hidden = NO;
			break; 		
		case 420: //WORLD 4
			suiv.hidden = NO;
			prec.hidden = YES;
			hint1B.hidden = NO;
			hint2B.hidden = NO;
			hint3B.hidden = NO;
			break;
		case 421:
			suiv.hidden = YES;
			prec.hidden = NO;
			hint1B.hidden = NO;
			hint2B.hidden = NO;
			hint3B.hidden = NO;
			break; 			
		case 430: //WORLD 4
			suiv.hidden = NO;
			prec.hidden = YES;
			hint1B.hidden = NO;
			hint2B.hidden = NO;
			hint3B.hidden = NO;
			break;
		case 431:
			suiv.hidden = YES;
			prec.hidden = NO;
			hint1B.hidden = NO;
			hint2B.hidden = NO;
			hint3B.hidden = NO;
			break; 	
		case 550: //WORLD 5
			suiv.hidden = NO;
			prec.hidden = YES;
			hint1B.hidden = NO;
			hint2B.hidden = NO;
			hint3B.hidden = NO;
			break;
		case 551:
			suiv.hidden = YES;
			prec.hidden = NO;
			hint1B.hidden = NO;
			hint2B.hidden = NO;
			hint3B.hidden = NO;
			break;
		case 560:
			suiv.hidden = NO;
			prec.hidden = YES;
			hint1B.hidden = NO;
			hint2B.hidden = NO;
			hint3B.hidden = NO;
			break;	
		case 561:
			suiv.hidden = YES;
			prec.hidden = NO;
			hint1B.hidden = NO;
			hint2B.hidden = NO;
			hint3B.hidden = NO;
			break;			
		case 680: //WORLD 6
			idLvL = 680;	
			suiv.hidden = NO;
			prec.hidden = YES;
			hint1B.hidden = NO;
			hint2B.hidden = NO;
			hint3B.hidden = NO;
			break;
		case 681:
			idLvL = 681;
			suiv.hidden = NO;
			prec.hidden = NO;
			hint1B.hidden = NO;
			hint2B.hidden = NO;
			hint3B.hidden = NO;
			break;		
		case 682:
			idLvL = 682;
			suiv.hidden = YES;
			prec.hidden = NO;
			hint1B.hidden = NO;
			hint2B.hidden = NO;
			hint3B.hidden = NO;
			break;		
		case 710: //WORLD 7
			suiv.hidden = YES;
			prec.hidden = YES;
			hint1B.hidden = NO;
			hint2B.hidden = NO;
			hint3B.hidden = NO;
			break;		
		default:
			suiv.hidden = YES;
			prec.hidden = YES;
			hint1B.hidden = NO;
			hint2B.hidden = NO;
			hint3B.hidden = NO;
			break;
	}	
}

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad 
{
	//NSLog(@"hintViewController viewDidLoad");
	
	[self loadWebView:idLvLCourant];
	
	// Emulated CD support through MP3
	NSURL *url = [NSURL fileURLWithPath:[NSString stringWithFormat:@"%@/button-28.mp3", [[NSBundle mainBundle] resourcePath]]];
	NSError *err;
	menuSFXPlayer = [[AVAudioPlayer alloc] initWithContentsOfURL:url error:&err];
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	menuSFXPlayer.numberOfLoops = 0;
	
	url = [NSURL fileURLWithPath:[NSString stringWithFormat:@"%@/button-25.mp3", [[NSBundle mainBundle] resourcePath]]];
	hintPlayer = [[AVAudioPlayer alloc] initWithContentsOfURL:url error:&err];
	hintPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	hintPlayer.numberOfLoops = 0;
	
    [super viewDidLoad];	
}

-(IBAction) precClickedDown:(id)sender
{
	if( idLvL == 682 )
		[self loadWebView:idLvL-1];
	else
		[self loadWebView:idLvLCourant];
	
	if( _GobLanguage == 0 )
	{
		[hint1B setImage:[UIImage imageNamed:@"hint1_s.png"] forState:UIControlStateNormal];
		[hint2B setImage:[UIImage imageNamed:@"hint2.png"] forState:UIControlStateNormal];
		[hint3B setImage:[UIImage imageNamed:@"hint3.png"] forState:UIControlStateNormal];		
	}
	else if( _GobLanguage == 1 )
	{
		[hint1B setImage:[UIImage imageNamed:@"hint1_fr_s.png"] forState:UIControlStateNormal];
		[hint2B setImage:[UIImage imageNamed:@"hint2_fr.png"] forState:UIControlStateNormal];
		[hint3B setImage:[UIImage imageNamed:@"hint3_fr.png"] forState:UIControlStateNormal];		
	}
}

-(IBAction) suivClickedDown:(id)sender
{
	if( idLvL == 681)
		[self loadWebView:idLvL+1];
	else
		[self loadWebView:idLvLCourant+1];
	
	if( _GobLanguage == 0 )
	{
		[hint1B setImage:[UIImage imageNamed:@"hint1_s.png"] forState:UIControlStateNormal];
		[hint2B setImage:[UIImage imageNamed:@"hint2.png"] forState:UIControlStateNormal];
		[hint3B setImage:[UIImage imageNamed:@"hint3.png"] forState:UIControlStateNormal];		
	}
	else if( _GobLanguage == 1 )
	{
		[hint1B setImage:[UIImage imageNamed:@"hint1_fr_s.png"] forState:UIControlStateNormal];
		[hint2B setImage:[UIImage imageNamed:@"hint2_fr.png"] forState:UIControlStateNormal];
		[hint3B setImage:[UIImage imageNamed:@"hint3_fr.png"] forState:UIControlStateNormal];		
	}
}

// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return ( interfaceOrientation == UIInterfaceOrientationLandscapeRight || interfaceOrientation == UIInterfaceOrientationLandscapeLeft );
}

- (void)didReceiveMemoryWarning 
{
	//NSLog(@"hintViewController didReceiveMemoryWarning");
	
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
	if( activityIndicator != nil )
	{
		[activityIndicator release];
		activityIndicator = nil;
	}
	
	[menuSFXPlayer stop];
	if( menuSFXPlayer != nil )
	{
		[menuSFXPlayer release];
		menuSFXPlayer = nil;
	}
}

- (void)viewDidUnload 
{
	//NSLog(@"hintViewController viewDidUnload");
	
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
	if( hintView != nil )
	{
		[hintView release];
		hintView = nil;
	}
	if( activityIndicator != nil )
	{
		[activityIndicator release];
		activityIndicator = nil;
	}
}

- (void)dealloc 
{
	//NSLog(@"hintViewController dealloc");	
	
	if( hintView != nil )
	{
		[hintView release];
		hintView = nil;
	}
	if( activityIndicator != nil )
	{
		[activityIndicator release];
		activityIndicator = nil;
	}
	if( hint1B != nil )
	{
		[hint1B release];
		hint1B = nil;
	}
	if( hint2B != nil )
	{
		[hint2B release];
		hint2B = nil;
	}
	if( hint3B != nil )
	{
		[hint3B release];
		hint3B = nil;
	}
	if( suiv != nil )
	{
		[suiv release];
		suiv = nil;
	}
	if( prec != nil )
	{
		[prec release];
		prec = nil;
	}
	
	if( menuSFXPlayer != nil )
	{
		[menuSFXPlayer release];
		menuSFXPlayer = nil;
	}
	if( hintPlayer != nil )
	{
		[hintPlayer release];
		hintPlayer = nil;
	}

	
    [super dealloc];		
}

//back click to iPhoneView
-(IBAction) backClickedDown:(id)sender
{
	//NSLog(@"hintViewController backClickedDown");	
	[menuSFXPlayer stop];	
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	[menuSFXPlayer play];
	
	bSleepMode = false;
	if( bSem )
	{
		sem_post( sem );		
		bSem = false;
	}
	
	[UIView beginAnimations:nil context:self]; 
	{
		[UIView setAnimationDuration:1.0];
		[UIView setAnimationDelegate:self];
		[UIView setAnimationDidStopSelector:@selector(animationFinished:finished:context:)];
		[UIView setAnimationCurve:UIViewAnimationCurveEaseInOut];	
		self.view.frame = CGRectMake( 0, 320, self.view.frame.size.width, self.view.frame.size.height );
	}
	[UIView commitAnimations];
}

- (void)animationFinished:(NSString *)animationID finished:(NSNumber *)finished context:(void *)context 
{
	[self.view removeFromSuperview];
	bHintMenuActive = false;
}

-(IBAction) hint1ClickedDown:(id)sender
{
	//NSLog(@"hintViewController hint1ClickedDown");
	[menuSFXPlayer stop];	
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	[menuSFXPlayer play];	
	
	if( _GobLanguage == 0 )
	{
		[hint1B setImage:[UIImage imageNamed:@"hint1_s.png"] forState:UIControlStateNormal];
		[hint2B setImage:[UIImage imageNamed:@"hint2.png"] forState:UIControlStateNormal];
		[hint3B setImage:[UIImage imageNamed:@"hint3.png"] forState:UIControlStateNormal];		
	}
	else if( _GobLanguage == 1 )
	{
		[hint1B setImage:[UIImage imageNamed:@"hint1_fr_s.png"] forState:UIControlStateNormal];
		[hint2B setImage:[UIImage imageNamed:@"hint2_fr.png"] forState:UIControlStateNormal];
		[hint3B setImage:[UIImage imageNamed:@"hint3_fr.png"] forState:UIControlStateNormal];		
	}
	
	[hintView stringByEvaluatingJavaScriptFromString:[NSString stringWithFormat:@"document.getElementById('hint1').style.display='block';"]];	
	[hintView stringByEvaluatingJavaScriptFromString:[NSString stringWithFormat:@"document.getElementById('hint2').style.display='none';"]];
	[hintView stringByEvaluatingJavaScriptFromString:[NSString stringWithFormat:@"document.getElementById('hint3').style.display='none';"]];	
}

-(IBAction) hint2ClickedDown:(id)sender
{
	//NSLog(@"hintViewController hint2ClickedDown");
	[menuSFXPlayer stop];	
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	[menuSFXPlayer play];
	
	if( _GobLanguage == 0 )
	{
		[hint1B setImage:[UIImage imageNamed:@"hint1.png"] forState:UIControlStateNormal];
		[hint2B setImage:[UIImage imageNamed:@"hint2_s.png"] forState:UIControlStateNormal];
		[hint3B setImage:[UIImage imageNamed:@"hint3.png"] forState:UIControlStateNormal];		
	}
	else if( _GobLanguage == 1 )
	{
		[hint1B setImage:[UIImage imageNamed:@"hint1_fr.png"] forState:UIControlStateNormal];
		[hint2B setImage:[UIImage imageNamed:@"hint2_fr_s.png"] forState:UIControlStateNormal];
		[hint3B setImage:[UIImage imageNamed:@"hint3_fr.png"] forState:UIControlStateNormal];		
	}
	
	[hintView stringByEvaluatingJavaScriptFromString:[NSString stringWithFormat:@"document.getElementById('hint2').style.display='block';"]];	
	[hintView stringByEvaluatingJavaScriptFromString:[NSString stringWithFormat:@"document.getElementById('hint1').style.display='none';"]];
	[hintView stringByEvaluatingJavaScriptFromString:[NSString stringWithFormat:@"document.getElementById('hint3').style.display='none';"]];	
}

-(IBAction) hint3ClickedDown:(id)sender
{
	//NSLog(@"hintViewController hint3ClickedDown");
	[menuSFXPlayer stop];	
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	[menuSFXPlayer play];
	
	if( _GobLanguage == 0 )
	{
		[hint1B setImage:[UIImage imageNamed:@"hint1.png"] forState:UIControlStateNormal];
		[hint2B setImage:[UIImage imageNamed:@"hint2.png"] forState:UIControlStateNormal];
		[hint3B setImage:[UIImage imageNamed:@"hint3_s.png"] forState:UIControlStateNormal];		
	}
	else if( _GobLanguage == 1 )
	{
		[hint1B setImage:[UIImage imageNamed:@"hint1_fr.png"] forState:UIControlStateNormal];
		[hint2B setImage:[UIImage imageNamed:@"hint2_fr.png"] forState:UIControlStateNormal];
		[hint3B setImage:[UIImage imageNamed:@"hint3_fr_s.png"] forState:UIControlStateNormal];		
	}
	
	[hintView stringByEvaluatingJavaScriptFromString:[NSString stringWithFormat:@"document.getElementById('hint3').style.display='block';"]];	
	[hintView stringByEvaluatingJavaScriptFromString:[NSString stringWithFormat:@"document.getElementById('hint2').style.display='none';"]];
	[hintView stringByEvaluatingJavaScriptFromString:[NSString stringWithFormat:@"document.getElementById('hint1').style.display='none';"]];	
}

//DELEGATES

//UIWebView
- (void)webView:(UIWebView *)webView didFailLoadWithError:(NSError *)error
{
	//NSLog(@"hintViewController didFailLoadWithError");
	[activityIndicator stopAnimating];
	NSMutableString *html = [[NSMutableString alloc] initWithString: @"<html><head></head><style type=\"text/css\">body{ background-color: transparent; color: #ffffff;</style><body>"];
	[html appendString: @"Error"];
	[html appendString: @"</body></html>"];
	[hintView loadHTMLString:html baseURL:nil];
}

- (void)webViewDidFinishLoad:(UIWebView *)webView
{
	//NSLog(@"hintViewController webViewDidFinishLoad");
	[activityIndicator stopAnimating];
	activityIndicator.hidden = YES;
}

- (void)webViewDidStartLoad:(UIWebView *)webView
{
	//NSLog(@"hintViewController webViewDidStartLoad");
	activityIndicator.hidden = NO;
	[activityIndicator startAnimating];
}

@end
