//
//  saveViewController.m
//  Gob2
//
//  Created by DotEmu on 14/06/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//
#include <semaphore.h>
#include <fstream>
#import "iphone_video.h"
#import "iphone_common.h"
#import "Gob1MenuViewController.h"
#import "switchViewController.h"
#import "iPhoneViewController.h"
#import "saveViewController.h"

extern bool bMenuIngame;
extern bool bFromMenuIngame;
extern bool bSaveActive;
extern bool bMenuGob1;
extern bool bSimulation;
extern bool bLoadSimulLaunch;
extern bool bEndGame;
extern bool bSleepMode;

extern int idSoundSFX;
extern int bGob2Action;
extern uint16 *_fullscreen;

extern AVAudioPlayer* menuPlayer;
extern iPhoneViewController* g_iVC;
extern menuigViewController* g_menuigVC;
extern switchViewController* g_switchVC;
extern Gob1MenuViewController* g_gob1MenuVC;

int slotSave = 0;

extern bool bSem;
extern sem_t* sem;

extern int _GobLanguage;

extern int fingusLeft, fingusTop;

extern NSString* _plat;

@implementation saveViewController

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

- (void) LoadEmptySlotClicked:(id)sender
{
	[[[UIAlertView alloc] initWithTitle:NSLocalizedString(@"LoadSlotTitle", @"Slot empty") message:NSLocalizedString(@"LoadSlotText", @"This slot is empty. Try to load another slot!") delegate:self cancelButtonTitle:@"OK" otherButtonTitles:nil, nil] show];		 
}

-(void) writeSave:(int)iii
{
	//NSLog(@"iPhoneView writeSettingsLvL");		
    std::fstream settingsFile;
	NSString *txt = [NSString stringWithFormat:@"SAVE%d.DAT", iii];
	docsDirectory = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
    path_save = [docsDirectory stringByAppendingPathComponent:txt];
	
	NSFileManager* fileManager = [NSFileManager defaultManager];
	[fileManager removeItemAtPath:path_save error:NULL];
	
    settingsFile.open([path_save UTF8String], std::fstream::out | std::fstream::app);
    if(!settingsFile.is_open())
    {
        ;//NSLog(@"Can't create/open file %@", path_save);
    }
	
	// Get the time
	NSCalendar *calendar= [[NSCalendar alloc] initWithCalendarIdentifier:NSGregorianCalendar];
	NSCalendarUnit unitFlags = NSYearCalendarUnit | NSMonthCalendarUnit | NSDayCalendarUnit | NSHourCalendarUnit | NSMinuteCalendarUnit | NSSecondCalendarUnit;
	NSDate *date = [NSDate date];
	NSDateComponents *dateComponents = [calendar components:unitFlags fromDate:date];
	
	// Turn the date into Integers
	NSInteger year = [dateComponents year];
	NSInteger month = [dateComponents month];
	NSInteger day = [dateComponents day];
	NSInteger hour = [dateComponents hour];
	NSInteger min = [dateComponents minute];
	
    NSString* infosTabSeparated = [[NSString alloc] initWithFormat:@"%d %d %d %d %d   \t", month, day, year, hour, min];
    int buffLength = [infosTabSeparated length];
    char* buffer = new char[buffLength];
    [infosTabSeparated getBytes:(void*)buffer maxLength:buffLength usedLength:NULL encoding:NSUTF8StringEncoding options:NSStringEncodingConversionAllowLossy range:NSMakeRange(0, buffLength) remainingRange:NULL];
    settingsFile.write (buffer, buffLength);
    settingsFile.close();
    [infosTabSeparated release];
    delete[] buffer;
}

-(void) loadButtonsSave:(int)iii
{
	_saveSlot[iii] = [[UIButton buttonWithType:UIButtonTypeCustom] retain];
	_saveSlot[iii].frame = CGRectMake( 85, iii*100, 125, 80 );
	
	_saveLoad[iii] = [[UIButton buttonWithType:UIButtonTypeCustom] retain];
	if( _GobLanguage == 0 )
		_saveLoad[iii].frame = CGRectMake( 310, (iii*80+iii*21) + 40, 51, 26 );
	else if( _GobLanguage == 1 )
		_saveLoad[iii].frame = CGRectMake( 290, (iii*80+iii*21) + 40, 115, 26 );		
	
	_saveLabel[iii] = [[UILabel alloc ] initWithFrame:CGRectMake( 240, (iii*80+iii*21) + 15, 300, 30 )];
	
	NSString *intString = [NSString stringWithFormat:@"save%d.png", iii];
	docsDirectory = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
	path = [docsDirectory stringByAppendingPathComponent:intString];
	NSString *txt = [NSString stringWithFormat:@"SAVE%d.DAT", iii];
    path_save = [docsDirectory stringByAppendingPathComponent:txt];
	NSFileManager* fileManager = [NSFileManager defaultManager];
	
	if( [fileManager fileExistsAtPath:path] )
	{
		CGSize size = CGSizeMake(125, 80);
		UIGraphicsBeginImageContext( size );
		
		myImage[iii] = [UIImage imageWithContentsOfFile:path];	
		[myImage[iii] drawInRect:CGRectMake(0,0,size.width,size.height)];
		myImage[iii] = UIGraphicsGetImageFromCurrentImageContext();
		UIGraphicsEndImageContext();	
	
		int month(0), day(0), year(0), hour(0), min(0);
		if( [fileManager fileExistsAtPath:path_save] )
		{
			NSString *fileString = [NSString stringWithContentsOfFile:path_save encoding:NSUTF8StringEncoding error:nil];
			NSArray *mArray = [fileString componentsSeparatedByString:@"\n"];
			NSString *ll = mArray.lastObject;
			
			if( ll != nil )
			{
				month = [[ll substringWithRange:NSMakeRange(0, 2)] intValue];
				if( month >= 10 )
				{
					day = [[ll substringWithRange:NSMakeRange(3, 2)] intValue];
					if( day >= 10 )
					{
						year = [[ll substringWithRange:NSMakeRange(6, 4)] intValue];
						hour = [[ll substringWithRange:NSMakeRange(11, 2)] intValue];	
						if( hour >= 10 )
							min = [[ll substringWithRange:NSMakeRange(14, 2)] intValue];	
						else
							min = [[ll substringWithRange:NSMakeRange(13, 2)] intValue];
					}
					else
					{
						year = [[ll substringWithRange:NSMakeRange(5, 4)] intValue];
						hour = [[ll substringWithRange:NSMakeRange(10, 2)] intValue];	
						if( hour >= 10 )
							min = [[ll substringWithRange:NSMakeRange(13, 2)] intValue];	
						else
							min = [[ll substringWithRange:NSMakeRange(12, 2)] intValue];
					}
				}
				else
				{
					day = [[ll substringWithRange:NSMakeRange(2, 2)] intValue];	
					if( day >= 10 )
					{
						year = [[ll substringWithRange:NSMakeRange(5, 4)] intValue];
						hour = [[ll substringWithRange:NSMakeRange(10, 2)] intValue];	
						if( hour >= 10 )
							min = [[ll substringWithRange:NSMakeRange(13, 2)] intValue];	
						else
							min = [[ll substringWithRange:NSMakeRange(12, 2)] intValue];
					}
					else
					{
						year = [[ll substringWithRange:NSMakeRange(4, 4)] intValue];	
						hour = [[ll substringWithRange:NSMakeRange(9, 2)] intValue];
						if( hour >= 10 )
							min = [[ll substringWithRange:NSMakeRange(12, 2)] intValue];	
						else
							min = [[ll substringWithRange:NSMakeRange(11, 2)] intValue];
					}
				}
			}
		}
		
		NSData* someData = [[NSData alloc] initWithContentsOfFile:[docsDirectory stringByAppendingPathComponent:txt]];
		//NSLog([[[NSString alloc] initWithData:someData encoding:NSUTF8StringEncoding] autorelease]);
		
		NSString *blo;
		if( _GobLanguage == 0 )
		{
			if( min < 10 )
				blo = [NSString stringWithFormat:@"Slot %d - %d/%d/%d @ %d:0%d", iii+1, month, day, year, hour, min];
			else
				blo = [NSString stringWithFormat:@"Slot %d - %d/%d/%d @ %d:%d", iii+1, month, day, year, hour, min];		
		}
		else if( _GobLanguage == 1 )
		{
			if( min < 10 )
				blo = [NSString stringWithFormat:@"Empl. %d - %d/%d/%d @ %d:0%d", iii+1, day, month, year, hour, min];
			else
				blo = [NSString stringWithFormat:@"Empl. %d - %d/%d/%d @ %d:%d", iii+1, day, month, year, hour, min];				
		}
		_saveLabel[iii].text = blo;
	}
	else
	{
		myImage[iii] = [[UIImage imageNamed:@"rond barré.png"] retain];
		NSString *bla;
		if( _GobLanguage == 0 )
			bla = [NSString stringWithFormat:@"Slot %d - Empty", iii+1];
		else if( _GobLanguage == 1 )
			bla = [NSString stringWithFormat:@"Emplacement %d - Vide", iii+1];			
		_saveLabel[iii].text = bla;
	}

	[_saveSlot[iii] setImage:myImage[iii] forState:UIControlStateNormal]; 		
	
	if( !bSaveActive && ![fileManager fileExistsAtPath:path] )
	{
		_saveLoad[iii].hidden = YES;			
		[_saveSlot[iii] addTarget:self action:@selector(LoadEmptySlotClicked:) forControlEvents:UIControlEventTouchDown];
	}
	else
	{
		[_saveSlot[iii] addTarget:self action:@selector(saveSlotClicked:) forControlEvents:UIControlEventTouchDown];
		[_saveLoad[iii] addTarget:self action:@selector(saveSlotClicked:) forControlEvents:UIControlEventTouchDown];
		_saveLoad[iii].hidden = NO;		
	}

	if( bSaveActive )
		[_saveLoad[iii] setImage:[[UIImage imageNamed:NSLocalizedString(@"SaveImgText", @"save-IG.png")] retain] forState:UIControlStateNormal]; 			
	else
		[_saveLoad[iii] setImage:[[UIImage imageNamed:NSLocalizedString(@"LoadImgText", @"load-IG.png")] retain] forState:UIControlStateNormal];

	//[myImage[iii] release];
	//myImage[iii] = nil;
	
	_saveLabel[iii].textColor = [UIColor whiteColor];
	_saveLabel[iii].backgroundColor = [UIColor clearColor];
	_saveLabel[iii].font = [UIFont fontWithName:@"Arial" size:16];
	
	[_scrollView addSubview:_saveLabel[iii]]; 
	[_scrollView addSubview:_saveSlot[iii]]; 
	[_scrollView addSubview:_saveLoad[iii]]; 	
}

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad 
{	
	//NSLog(@"saveViewController viewDidLoad");
	
	if( bSaveActive)
	{
		if( _GobLanguage == 0 )
			_titleV = [[UIImageView alloc] initWithFrame:CGRectMake(200, 25, 84, 37)];	
		else if( _GobLanguage == 1 )
			_titleV = [[UIImageView alloc] initWithFrame:CGRectMake(160, 25, 165, 37)];	
		UIImage *img = [[UIImage alloc] initWithContentsOfFile:[[NSBundle mainBundle] pathForResource:NSLocalizedString(@"SaveImgTitle", @"save_title") ofType:@"png"]];
		[_titleV setImage:img];
		[img release];
		[self.view addSubview:_titleV];
	}
	else
	{
		if( _GobLanguage == 0 )
			_titleV = [[UIImageView alloc] initWithFrame:CGRectMake(200, 25, 84, 37)];	
		else if( _GobLanguage == 1 )
			_titleV = [[UIImageView alloc] initWithFrame:CGRectMake(180, 25, 125, 37)];				
		UIImage *img = [[UIImage alloc] initWithContentsOfFile:[[NSBundle mainBundle] pathForResource:NSLocalizedString(@"LoadImgTitle", @"load_title") ofType:@"png"]];
		[_titleV setImage:img];
		[img release];
		[self.view addSubview:_titleV];
	}
	
	// Emulated CD support through MP3
	NSURL *url = [NSURL fileURLWithPath:[NSString stringWithFormat:@"%@/button-28.mp3", [[NSBundle mainBundle] resourcePath]]];
	NSError *error;
	menuSFXPlayer = [[AVAudioPlayer alloc] initWithContentsOfURL:url error:&error];
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	menuSFXPlayer.numberOfLoops = 0;
	
	bBackActive = true;

	//PRINT IMG SAVE
	for( int i = 0; i < 5; ++i )
	{
		[self clearButtons:i];
		[self loadButtonsSave:i];
	}
	
	[_scrollView setContentSize:CGSizeMake(480, 500)];
	
    [super viewDidLoad];
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning 
{
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload 
{
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc
{
	//NSLog(@"saveViewController dealloc");
	
	if( _scrollView != nil )
	{
		[_scrollView release];
		_scrollView = nil;
	}
	if( _back != nil )
	{
		[_back release];
		_back = nil;
	}
	
	for( int i = 0; i < 5; ++i )
	{
		if( _saveSlot[i] != nil )
		{
			[_saveSlot[i]  release];
			_saveSlot[i]  = nil;
		}
		if( _saveLoad[i] != nil )
		{
			[_saveLoad[i]  release];
			_saveLoad[i]  = nil;
		}
		if( _saveLabel[i] != nil )
		{
			[_saveLabel[i]  release];
			_saveLabel[i]  = nil;
		}
		if( activityIndicator[i] != nil )
		{
			[activityIndicator[i]  release];
			activityIndicator[i]  = nil;
		}
		/*if( myImage[i] != nil )
		{
			[myImage[i]  release];
			myImage[i]  = nil;
		}*/
	}
	if( _titleV != nil )
	{
		[_titleV release];
		_titleV = nil;
	}

	if( menuSFXPlayer != nil )
	{
		[menuSFXPlayer release];
		menuSFXPlayer = nil;
	}
	
	if( alert != nil )
	{
		[alert release];
		alert = nil;
	}

	docsDirectory = nil;
	path = nil;
	path_save = nil;	
	
    [super dealloc];
}

-(bool)pathExists:(int)iii
{
	NSString *intString = [NSString stringWithFormat:@"save%d.png", iii];	
	docsDirectory = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
	path = [docsDirectory stringByAppendingPathComponent:intString];	
	
	NSFileManager* fileManager = [NSFileManager defaultManager];
	
	if( [fileManager fileExistsAtPath:path] )
		return true;
	
	return false;
}

-(int)torgba:(uint16_t)i
{
	uint16_t temp = i; // swap bytes for Big-Endian (data[0] = 0xRRRRRGGG, data[1] = 0xGGGBBBBB) bitmap
	uint8_t red, green, blue; //these only need to be one byte each
	red = (temp >> 11) & 0x1F;
	green = (temp >> 5) & 0x3F;
	blue = (temp & 0x001F);    
	red = (red << 3) | (red >> 2);
	green = (green << 2) | (green >> 4);
	blue = (blue << 3) | (blue >> 2);    
	
	return (int)((red << 24) | (green << 16) | (blue << 8) | 0xFF);
}

-(void) printSaveScreen:(int)iii
{
	int a[320*200] = { 0 };
	for(int i = 0; i <320*200; i++)
		a[i] = [self torgba:_fullscreen[i]];
	
	// make data provider with data.
	CGDataProviderRef provider = CGDataProviderCreateWithData(NULL, &a, 320*200*4, NULL);
	
	// prep the ingredients
	int bitsPerComponent = 8;
	int bitsPerPixel = 32;
	int bytesPerRow = 4 * 320;
	
	CGColorSpaceRef colorSpaceRef = CGColorSpaceCreateDeviceRGB();
	CGBitmapInfo bitmapInfo = kCGBitmapByteOrder32Little;
	CGColorRenderingIntent renderingIntent = kCGRenderingIntentDefault;
	
	// make the cgimage
	CGImageRef imageRef = CGImageCreate(320, 200, bitsPerComponent, bitsPerPixel, bytesPerRow, colorSpaceRef, bitmapInfo, provider, NULL, NO, renderingIntent);
	
	// then make the uiimage from that
	myImage[iii] = [UIImage imageWithCGImage:imageRef];	
	
	NSString *intString = [NSString stringWithFormat:@"save%d.png", iii];
	
	docsDirectory = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
	path = [docsDirectory stringByAppendingPathComponent:intString];	
	
	NSFileManager* fileManager = [NSFileManager defaultManager];
	[fileManager removeItemAtPath:path error:NULL];
	
	NSData *imageData = [NSData dataWithData:UIImagePNGRepresentation(myImage[iii])];
	[imageData writeToFile:path atomically:YES];
	
	myImage[iii] = [UIImage imageWithContentsOfFile:path];
	
	CGSize size = CGSizeMake(142, 92);
	UIGraphicsBeginImageContext( size );
	[myImage[iii] drawInRect:CGRectMake(0,0,size.width,size.height)];
	myImage[iii] = UIGraphicsGetImageFromCurrentImageContext();
	UIGraphicsEndImageContext();
	
	CGDataProviderRelease(provider);
	CGColorSpaceRelease(colorSpaceRef);
	CGImageRelease(imageRef);
}


- (void)animationFinished:(NSString *)animationID finished:(NSNumber *)finished context:(void *)context 
{
	[self.view removeFromSuperview];
	
	bMenuIngame = true;
	bFromMenuIngame = false;
}

-(IBAction) backClicked:(id)sender
{
	//NSLog(@"saveViewController backClicked");
	if( bBackActive )
	{
		[menuSFXPlayer stop];	
		menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
		[menuSFXPlayer play];
		
		[UIView beginAnimations:nil context:self]; 
		{
			[UIView setAnimationDuration:1.0];
			[UIView setAnimationDelegate:self];
			[UIView setAnimationDidStopSelector:@selector(animationFinished:finished:context:)];
			[UIView setAnimationCurve:UIViewAnimationCurveEaseInOut];	
			self.view.frame = CGRectMake( self.view.frame.size.width, 0, self.view.frame.size.width, self.view.frame.size.height );
		}
		[UIView commitAnimations];
		
		[g_iVC.view addSubview:g_menuigVC.view];
		
		[[NSNotificationCenter defaultCenter] postNotificationName:@"enableButtonMenuNotif" object:nil];
		[[NSNotificationCenter defaultCenter] postNotificationName:@"resetPosToFingusNotif" object:nil];	

		
		//DEBUG
		[[NSNotificationCenter defaultCenter] postNotificationName:@"interactionOnNotif" object:nil];
		[[NSNotificationCenter defaultCenter] postNotificationName:@"UIBackFromSavingNotif" object:nil];
	}
}

-(void) clearButtons:(int)iid
{
	if( _saveSlot[iid] != nil && _saveSlot[iid].superview != nil )
	{
		[_saveSlot[iid] removeFromSuperview];
		[_saveSlot[iid] release];
		_saveSlot[iid] = nil;
	}
	
	if( _saveLoad[iid] != nil && _saveLoad[iid].superview != nil )
	{
		[_saveLoad[iid] removeFromSuperview];
		[_saveLoad[iid] release];
		_saveLoad[iid] = nil;
	}
	
	if( _saveLabel[iid]  && _saveLabel[iid].superview != nil )
	{
		[_saveLabel[iid] removeFromSuperview];
		[_saveLabel[iid] release];
		_saveLabel[iid] = nil;
	}
}

- (void) emptyBag
{
	if( bGob2Action == 1 )
	{
		[(iPhoneView*)g_iVC.view addEvent:[[NSDictionary alloc] initWithObjectsAndKeys:[NSNumber numberWithInt:kButtonRightDown], @"type",
										   [NSNumber numberWithFloat:0], @"x",
										   [NSNumber numberWithFloat:0], @"y",nil]];
		
		[(iPhoneView*)g_iVC.view addEvent:[[NSDictionary alloc] initWithObjectsAndKeys:[NSNumber numberWithInt:kTempo], @"type",
										   [NSNumber numberWithFloat:0], @"x",
										   [NSNumber numberWithFloat:0], @"y",nil]];
		
		[(iPhoneView*)g_iVC.view addEvent:[[NSDictionary alloc] initWithObjectsAndKeys:[NSNumber numberWithInt:kTempo], @"type",
										   [NSNumber numberWithFloat:0], @"x",
										   [NSNumber numberWithFloat:0], @"y",nil]];
		
		[(iPhoneView*)g_iVC.view addEvent:[[NSDictionary alloc] initWithObjectsAndKeys:[NSNumber numberWithInt:kButtonRightDown], @"type",
										   [NSNumber numberWithFloat:0], @"x",
										   [NSNumber numberWithFloat:0], @"y",nil]];
		
		//[NSTimer scheduledTimerWithTimeInterval:0.5 target:self selector:@selector(saveSlot:) userInfo:nil repeats:NO];
	}
}

-(void) stopSaving
{
	//NSLog(@"saveViewController stopSaving");	
	bBackActive = true;
	bSaving = false;
	if( activityIndicator[ident] != nil )
	{
		activityIndicator[ident].hidden = YES;
		[activityIndicator[ident] stopAnimating];
		[activityIndicator[ident] removeFromSuperview];
		[activityIndicator[ident] release];
		activityIndicator[ident] = nil;
	}
	[self clearButtons:ident];
	[self loadButtonsSave:ident];
	/*g_system->warpMouse(100,100);
	[(iPhoneView*)g_iVC.view addEvent:[[NSDictionary alloc] initWithObjectsAndKeys:[NSNumber numberWithInt:kButtonLeftDown], @"type",
									   [NSNumber numberWithFloat:100], @"x",
									   [NSNumber numberWithFloat:100], @"y",nil]];*/
	
	/*float xTouch = fingusLeft + 10;
	float yTouch = fingusTop + 10;
	if( yTouch <= 10 ) yTouch = 10;
	g_system->warpMouse( xTouch, yTouch );
	
	[(iPhoneView*)g_iVC.view addEvent:[[NSDictionary alloc] initWithObjectsAndKeys:[NSNumber numberWithInt:kButtonLeftDown], @"type",
									   [NSNumber numberWithFloat:xTouch], @"x",
									   [NSNumber numberWithFloat:yTouch], @"y",nil]];*/
	[[NSNotificationCenter defaultCenter] postNotificationName:@"resetPosToFingusNotif" object:nil];
	
	bSleepMode = true;
	
	//DEBUG
	//[[NSNotificationCenter defaultCenter] postNotificationName:@"interactionOnNotif" object:nil];
	//[[NSNotificationCenter defaultCenter] postNotificationName:@"UIBackFromSavingNotif" object:nil];	
}

- (void) computeSaving
{
	//SAVE
	slotSave = ident;
	g_system->warpMouse(20,0);
	[(iPhoneView*)g_iVC.view addEvent:[[NSDictionary alloc] initWithObjectsAndKeys:[NSNumber numberWithInt:kButtonSaveSimulation], @"type",
									   [NSNumber numberWithFloat:0], @"x",
									   [NSNumber numberWithFloat:0], @"y",nil]];
	//---
	
	[self writeSave:ident];
	
	if( [_plat isEqualToString:@"iPhone3,1"] || [_plat isEqualToString:@"iPhone2,1"] || [_plat isEqualToString:@"iPod3,1"] || [_plat isEqualToString:@"iPod4,1"] )
	{
		//NSLog(@"3GS ou 4");
		[NSTimer scheduledTimerWithTimeInterval:3.5 target:self selector:@selector(stopSaving) userInfo:nil repeats:NO];
	}
	else
	{
		//NSLog(@"3G");
		[NSTimer scheduledTimerWithTimeInterval:7 target:self selector:@selector(stopSaving) userInfo:nil repeats:NO];
	}
}

-(void) saving
{
	/*float xTouch = fingusLeft + 10;
	float yTouch = fingusTop + 10;
	if( yTouch <= 10 ) yTouch = 10;
	g_system->warpMouse( xTouch, yTouch );
	
	[(iPhoneView*)g_iVC.view addEvent:[[NSDictionary alloc] initWithObjectsAndKeys:[NSNumber numberWithInt:kButtonLeftDown], @"type",
									   [NSNumber numberWithFloat:xTouch], @"x",
									   [NSNumber numberWithFloat:yTouch], @"y",nil]];*/
	[[NSNotificationCenter defaultCenter] postNotificationName:@"resetPosToFingusNotif" object:nil];
	
	[NSTimer scheduledTimerWithTimeInterval:0.5 target:self selector:@selector(emptyBag) userInfo:nil repeats:NO];	
	
	activityIndicator[ident] = [[UIActivityIndicatorView alloc] initWithFrame:CGRectMake( 135, ident*100 + 25, 30, 30)];
	activityIndicator[ident].activityIndicatorViewStyle = UIActivityIndicatorViewStyleWhiteLarge;
	activityIndicator[ident].hidden = NO;
	[activityIndicator[ident] startAnimating];
	[_scrollView addSubview:activityIndicator[ident]];
	
	[self printSaveScreen:ident];
	
	[self clearButtons:ident];
	
	//TEXT
	NSString *txt;
	if( _GobLanguage == 0 )
	{	
		txt = [NSString stringWithFormat:@"Saving Slot %d...", ident+1];
		_saveLabel[ident] = [[UILabel alloc ] initWithFrame:CGRectMake( 240, (ident*80+ident*21) + 25, 300, 30 )];			
	}
	else if( _GobLanguage == 1 )
	{
		txt = [NSString stringWithFormat:@"Sauvegarde empl. %d en cours...", ident+1];				
		_saveLabel[ident] = [[UILabel alloc ] initWithFrame:CGRectMake( 240, (ident*80+ident*21) + 25, 300, 30 )];
	}
	_saveLabel[ident].text = txt;
	_saveLabel[ident].textColor = [UIColor whiteColor];
	_saveLabel[ident].backgroundColor = [UIColor clearColor];
	_saveLabel[ident].font = [UIFont fontWithName:@"Arial" size:16];		
	[_scrollView addSubview:_saveLabel[ident]]; 
	
	[NSTimer scheduledTimerWithTimeInterval:1.5 target:self selector:@selector(computeSaving) userInfo:nil repeats:NO];
}

- (void) computeLoading
{
	g_system->warpMouse(20,0);
	slotSave = ident;
	[(iPhoneView*)g_iVC.view addEvent:[[NSDictionary alloc] initWithObjectsAndKeys:[NSNumber numberWithInt:kButtonLoadSimulation], @"type",
									   [NSNumber numberWithFloat:0], @"x",
									   [NSNumber numberWithFloat:0], @"y",nil]];	
	
	bBackActive = true;
	
	//release
	bMenuGob1 = false;
	[menuPlayer stop];
	if( g_gob1MenuVC != nil )
	{
		[g_gob1MenuVC releaseView];
		[g_gob1MenuVC.view removeFromSuperview];
	}
	
	if( activityIndicator[ident] != nil )
	{
		activityIndicator[ident].hidden = YES;
		[activityIndicator[ident] stopAnimating];
		[activityIndicator[ident] removeFromSuperview];
		[activityIndicator[ident] release];
		activityIndicator[ident] = nil;
	}
	[self clearButtons:ident];
	[self.view removeFromSuperview];
	bSaving = false;
	
	//DEBUG
	//[[NSNotificationCenter defaultCenter] postNotificationName:@"interactionOnNotif" object:nil];
}

-(void) loading
{
	//NSLog(@"loading");	
	/*float xTouch = fingusLeft + 10;
	float yTouch = fingusTop + 10;
	if( yTouch <= 10 ) yTouch = 10;
	g_system->warpMouse( xTouch, yTouch );
	
	[(iPhoneView*)g_iVC.view addEvent:[[NSDictionary alloc] initWithObjectsAndKeys:[NSNumber numberWithInt:kButtonLeftDown], @"type",
									   [NSNumber numberWithFloat:xTouch], @"x",
									   [NSNumber numberWithFloat:yTouch], @"y",nil]];*/
	[[NSNotificationCenter defaultCenter] postNotificationName:@"resetPosToFingusNotif" object:nil];
	[[NSNotificationCenter defaultCenter] postNotificationName:@"loadingScreenOnNotif" object:nil];		
	[NSTimer scheduledTimerWithTimeInterval:0.5 target:self selector:@selector(emptyBag) userInfo:nil repeats:NO];	
	[NSTimer scheduledTimerWithTimeInterval:1 target:self selector:@selector(computeLoading) userInfo:nil repeats:NO];
}

- (void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex 
{
	//NSLog(@"alertView didDismissWithButtonIndex");
	if (buttonIndex == 0) 
	{
		if( bSaveActive ) //save exists
			if( !bSem )
				[self saving];
		else
		{
			bSaving = false;
			bBackActive = true;	
		}
	}
	else
	{
		bSaving = false;
		bBackActive = true;			
	}
}

-(void)releaseMenuGob
{
	if( g_gob1MenuVC != nil )
	{
		[g_gob1MenuVC releaseView];
		[g_gob1MenuVC.view removeFromSuperview];
	}	
}

-(IBAction) saveSlotClicked:(id)sender
{
	//NSLog(@"saveViewController saveSlotClicked");	
	
	//DEBUG
	[[NSNotificationCenter defaultCenter] postNotificationName:@"interactionOffNotif" object:nil];		
	
	
	bSleepMode = false;
	if( bSem )
	{
		sem_post( sem );		
		bSem = false;
	}
	
	if( bGob2Action == 1 )
	{
		[(iPhoneView*)g_iVC.view addEvent:[[NSDictionary alloc] initWithObjectsAndKeys:[NSNumber numberWithInt:kButtonRightDown], @"type",
						[NSNumber numberWithFloat:0], @"x",
						[NSNumber numberWithFloat:0], @"y",nil]];
		
		[(iPhoneView*)g_iVC.view addEvent:[[NSDictionary alloc] initWithObjectsAndKeys:[NSNumber numberWithInt:kTempo], @"type",
						[NSNumber numberWithFloat:0], @"x",
						[NSNumber numberWithFloat:0], @"y",nil]];
		
		[(iPhoneView*)g_iVC.view addEvent:[[NSDictionary alloc] initWithObjectsAndKeys:[NSNumber numberWithInt:kTempo], @"type",
						[NSNumber numberWithFloat:0], @"x",
						[NSNumber numberWithFloat:0], @"y",nil]];
		
		[(iPhoneView*)g_iVC.view addEvent:[[NSDictionary alloc] initWithObjectsAndKeys:[NSNumber numberWithInt:kButtonRightDown], @"type",
						[NSNumber numberWithFloat:0], @"x",
						[NSNumber numberWithFloat:0], @"y",nil]];
		
		//[NSTimer scheduledTimerWithTimeInterval:0.5 target:self selector:@selector(saveSlot:) userInfo:nil repeats:NO];
	}
	
	if( !bSaving )
	{
		bSaving = true;
		bBackActive = false;
		for( int i = 0; i < 5; ++i )
		{
			if( _saveSlot[i] == sender || _saveLoad[i] == sender )
			{	
				ident = i;	
				
				//on sauvegarde	
				if( bSaveActive ) 
				{
					bool _exist = [self pathExists:i];
					
					if( _exist )
					{
						[[[UIAlertView alloc] initWithTitle:NSLocalizedString(@"SaveSlotTitle", @"Save exists") message:NSLocalizedString(@"SaveSlotText", @"This slot is already used. Are you sure to save on this slot?") delegate:self cancelButtonTitle:@"OK" otherButtonTitles:NSLocalizedString(@"PopupCancel", @"CANCEL"), nil] show];		
					}
					else
						[self saving];
				}
				else //on charge
				{
					if( bEndGame )					
						bFromMenuIngame = false;
					
					if( bFromMenuIngame )
						[self loading];
					else
					{
						bMenuGob1 = false;
						bSimulation = true;
						bLoadSimulLaunch = true;
						slotSave = ident;
						[self clearButtons:ident];
						[self.view removeFromSuperview];
						if( bEndGame )
						{							
							Gob::GobEngine *gg = (Gob::GobEngine*)[g_iVC getGobEngine]; 
							gg->quitGame();
							bEndGame = false;
							
							[[NSNotificationCenter defaultCenter] postNotificationName:@"loadingScreenOnNotif" object:nil];	
							[NSTimer scheduledTimerWithTimeInterval:0.5 target:self selector:@selector(releaseMenuGob) userInfo:nil repeats:NO];
						}
						else
						{
							[g_switchVC switchViews];	
							[[NSNotificationCenter defaultCenter] postNotificationName:@"loadingScreenOnNotif" object:nil];	
						}
					}
					[menuPlayer stop];
					[[NSNotificationCenter defaultCenter] postNotificationName:@"stopAnimNotif" object:nil];
					
				}
				break;
			}
		}
	}
}

@end
